function [D,PSSP,x]=modified_eigenERR(signal,d,f_centrale,var_fase,var_faseERR)
%
% Metodo MUSIC modificato per la stima della direzione di arrivo in situazione di
% parziale coerenza spaziale con un errore nella valutazione di B
%      var_faseERR <- varianza di fase errata(non corretta stima di B)
%      var_fase    <- variazione di fase da sensore a sensore
%      signal      <- dati dell'array lineare uniforme
%      d           <- numero delle sorgenti
%      delta       <- spaziatura fra i sensori
%      plot Pseudospettro   

[m,N]=size(signal);

% calcolo della matrice di covarianza campionata
R=signal*signal'/N;

B1=B_matrix(m,var_fase);
P=B1.*R;

B2=B_matrix(m,var_faseERR);

C=1./B2;
SH=C.*P;

passo=0.2;

naz=round(180/passo);
c=3e8;
delta=spaziatura(f_centrale);
[U,D,V]=svd(SH);

for ia=1:naz

Az=(ia-1-naz/2)*passo;

psi=[0:m-1]*2*pi*f_centrale*(delta/c)*sin(pi*Az/180);

a_theta=exp(-j*psi');

%calcolo della potenza del pseudo-spettro

sum=0;

for k=d+1:m

sum=sum+(abs(a_theta'*U(:,k)))^2;
end

Pseudospettro(ia)=1/sum;

end
PSSP=10*log10(Pseudospettro);
x=([1:naz]-1-naz/2)*passo;

plot(x,PSSP);
title('Metodo di Paulraj e Kailath(stima errata)');

xlabel('angoli di incidenza in gradi')

ylabel('Pseudospettro MUSIC(dB)') 
