function [signal,R,M]=ula_sin_som(fc,N,f,Az,m,f_centrale,Pn,SNR)
% fc=frequenza di campionamento
% N=num. campioni usato per stimare la matrice di covarianza d'array.
% Az=vettore contenete le DOA dei segnali.
% SNR=vettore dei rapporti segnale rumore in dB.
% Pn=potenza del rumore in volt^2.

tt=[1:N]/fc;

M=zeros(m,N);
c=3e8;
Stot=zeros(length(Az),N);

% spaziatura fra i sensori
delta=spaziatura(f_centrale);

for i=1:length(Az)
    
    Psi=Pn*10^(0.1*SNR(i));
    
    s=sqrt(2*Psi)*sin(2*pi*tt*f(i)+pi*i/2);
    
    ph=[0:m-1]*2*pi*f_centrale*(delta/c)*sin(pi*Az(i)/180);
    
    % colonna della matrice di Vandermonde
    A=exp(-j*ph');
  
    M=M+A*s;
    
    Stot(i,:)=s;
        
end

Rxx=cov(M');%simmetria coniugata, toeplitz.
Rxx2=Stot*Stot'/N;%quasi diagonale

noise=zeros(m,N);
noise=sqrt(Pn/2)*(randn(m,N)+j*randn(m,N));
signal=M+noise;

R=signal*conj(signal')/N;
